// automatically generated by the FlatBuffers compiler, do not modify

package Serialization;

import java.nio.*;
import java.lang.*;
import java.util.*;
import com.google.flatbuffers.*;

@SuppressWarnings("unused")
public final class BehaviorTree extends Table {
  public static void ValidateVersion() { Constants.FLATBUFFERS_1_12_0(); }
  public static BehaviorTree getRootAsBehaviorTree(ByteBuffer _bb) { return getRootAsBehaviorTree(_bb, new BehaviorTree()); }
  public static BehaviorTree getRootAsBehaviorTree(ByteBuffer _bb, BehaviorTree obj) { _bb.order(ByteOrder.LITTLE_ENDIAN); return (obj.__assign(_bb.getInt(_bb.position()) + _bb.position(), _bb)); }
  public void __init(int _i, ByteBuffer _bb) { __reset(_i, _bb); }
  public BehaviorTree __assign(int _i, ByteBuffer _bb) { __init(_i, _bb); return this; }

  public int rootUid() { int o = __offset(4); return o != 0 ? bb.getShort(o + bb_pos) & 0xFFFF : 0; }
  public Serialization.TreeNode nodes(int j) { return nodes(new Serialization.TreeNode(), j); }
  public Serialization.TreeNode nodes(Serialization.TreeNode obj, int j) { int o = __offset(6); return o != 0 ? obj.__assign(__indirect(__vector(o) + j * 4), bb) : null; }
  public int nodesLength() { int o = __offset(6); return o != 0 ? __vector_len(o) : 0; }
  public Serialization.TreeNode.Vector nodesVector() { return nodesVector(new Serialization.TreeNode.Vector()); }
  public Serialization.TreeNode.Vector nodesVector(Serialization.TreeNode.Vector obj) { int o = __offset(6); return o != 0 ? obj.__assign(__vector(o), 4, bb) : null; }
  public Serialization.NodeModel nodeModels(int j) { return nodeModels(new Serialization.NodeModel(), j); }
  public Serialization.NodeModel nodeModels(Serialization.NodeModel obj, int j) { int o = __offset(8); return o != 0 ? obj.__assign(__indirect(__vector(o) + j * 4), bb) : null; }
  public int nodeModelsLength() { int o = __offset(8); return o != 0 ? __vector_len(o) : 0; }
  public Serialization.NodeModel.Vector nodeModelsVector() { return nodeModelsVector(new Serialization.NodeModel.Vector()); }
  public Serialization.NodeModel.Vector nodeModelsVector(Serialization.NodeModel.Vector obj) { int o = __offset(8); return o != 0 ? obj.__assign(__vector(o), 4, bb) : null; }

  public static int createBehaviorTree(FlatBufferBuilder builder,
      int root_uid,
      int nodesOffset,
      int node_modelsOffset) {
    builder.startTable(3);
    BehaviorTree.addNodeModels(builder, node_modelsOffset);
    BehaviorTree.addNodes(builder, nodesOffset);
    BehaviorTree.addRootUid(builder, root_uid);
    return BehaviorTree.endBehaviorTree(builder);
  }

  public static void startBehaviorTree(FlatBufferBuilder builder) { builder.startTable(3); }
  public static void addRootUid(FlatBufferBuilder builder, int rootUid) { builder.addShort(0, (short)rootUid, (short)0); }
  public static void addNodes(FlatBufferBuilder builder, int nodesOffset) { builder.addOffset(1, nodesOffset, 0); }
  public static int createNodesVector(FlatBufferBuilder builder, int[] data) { builder.startVector(4, data.length, 4); for (int i = data.length - 1; i >= 0; i--) builder.addOffset(data[i]); return builder.endVector(); }
  public static void startNodesVector(FlatBufferBuilder builder, int numElems) { builder.startVector(4, numElems, 4); }
  public static void addNodeModels(FlatBufferBuilder builder, int nodeModelsOffset) { builder.addOffset(2, nodeModelsOffset, 0); }
  public static int createNodeModelsVector(FlatBufferBuilder builder, int[] data) { builder.startVector(4, data.length, 4); for (int i = data.length - 1; i >= 0; i--) builder.addOffset(data[i]); return builder.endVector(); }
  public static void startNodeModelsVector(FlatBufferBuilder builder, int numElems) { builder.startVector(4, numElems, 4); }
  public static int endBehaviorTree(FlatBufferBuilder builder) {
    int o = builder.endTable();
    return o;
  }
  public static void finishBehaviorTreeBuffer(FlatBufferBuilder builder, int offset) { builder.finish(offset); }
  public static void finishSizePrefixedBehaviorTreeBuffer(FlatBufferBuilder builder, int offset) { builder.finishSizePrefixed(offset); }

  public static final class Vector extends BaseVector {
    public Vector __assign(int _vector, int _element_size, ByteBuffer _bb) { __reset(_vector, _element_size, _bb); return this; }

    public BehaviorTree get(int j) { return get(new BehaviorTree(), j); }
    public BehaviorTree get(BehaviorTree obj, int j) {  return obj.__assign(__indirect(__element(j), bb), bb); }
  }
}

